Graphics3D 800,600,16,2
SetBuffer BackBuffer()

SeedRnd MilliSecs()

Global Camera = CreateCamera()

Include "Draw3D.bb" : DrawInit3D(Camera) : Origin3D(800,600)
Include "Vertex2D.bb"

InitVertex2D()

Global Tex2 = LoadImage3D("Tex2.jpg",4)
Global Tex1 = LoadImage3D("Tex1.jpg",4,2)
Global Native = LoadImage3D("GMaxA.png",2,3)


Global Test.mesh2D = Add2DMesh(Tex1,0,175)
	v0.vertex2D = Add2DVertex(Test,-50,+50)
	v1.vertex2D = Add2DVertex(Test,+50,+50)
	v2.vertex2D = Add2DVertex(Test,+50,-50)
	v3.vertex2D = Add2DVertex(Test,-50,-50)
	Add2DLine(Test,v0,v1)
	Add2DLine(Test,v1,v2)
	Add2DLine(Test,v2,v3)	
	Add2DLine(Test,v3,v0)
	SetMeshImage2D(Test,-50,+50,+50,+50,+50,-50,-50,-50)
	
Global Ball.mesh2D = Add2DMesh(Native,0,-100)
Const Stuck# = 180
Const Steps# = 360.0 / Stuck
Global Radius# = 50
	oldv.vertex2D = Add2DVertex(Ball,Radius,0)
	fv.vertex2D = oldv
	For wink# = 1 To Stuck-1
		newv.vertex2D = Add2DVertex(Ball,Cos(wink*Steps) * Radius,Sin(wink*Steps) * Radius)
		Add2DLine(Ball,newv,oldv)
		oldv = newv
	Next 
	Add2DLine(Ball,fv,oldv)
	SetMeshImage2D(Ball,-52.5,+52.5,+52.5,+52.5,+52.5,-52.5,-52.5,-52.5)
	
	;HideMesh2D Ball
	
Global Light1.light2D = Add2DLight(-200,200)
Global Light2.light2D = Add2DLight(200,-200)
Global Light3.light2D ;= Add2DLight(200,200)

For i = 1 To 0
	Add2DLight(Rand(-300,300),Rand(-200,200))
Next 

	

AmbientLight(10,10,10)

CameraClsColor(Camera,100,100,100)

InitLight2D(0.75)	

Repeat 
	
	FPSC = FPSC + 1
	If FPSMS <= MilliSecs() FPS = FPSC : FPSC = 0 : FPSMS = MilliSecs() + 1000
	
	UpdateVertex2D()
	
	TurnMesh2D(Test,0.1)
	
	If MouseDown(1)
		light1\x = MouseX3D
		light1\y = MouseY3D
	EndIf 
	If MouseDown(2)
		light2\x = MouseX3D
		light2\y = MouseY3D
	EndIf
;	If MouseDown(3)
;		light3\x = MouseX3D
;		light3\y = MouseY3D
;	EndIf
	
	Scale# = Abs(Sin(MilliSecs()/10))/2.0
	
	
	ScaleMesh2D(Test,0.5+Scale,0.5+Scale*3)
	ScaleMesh2D(Ball,0.5+Scale,0.5+Scale)
	
	ColorG3D(255,255,255,1)	 
	ColorN3D(100,100,100,1)
	;DrawQuad3D(Tex1,v0\m\x+v0\x,v0\m\y+v0\y,v1\m\x+v1\x,v1\m\y+v1\y,v2\m\x+v2\x,v2\m\y+v2\y,v3\m\x+v3\x,v3\m\y+v3\y)
	DrawRect3D(Tex2,0,0,0,0,800,600)
	;Oval3D(Native,Ball\x,Ball\y,45,45,2,10)
	
	If KeyHit(28)
		Nat = 1 - Nat
		If Nat = 1 Debug = Native Else Debug = 0
	EndIf 
	If KeyDown(17) WireFrame 1 Else WireFrame 0
	RenderVertex2D(Debug)
	RenderWorld()
	Text 0,0,fps
	Clear3D()
	Flip 0
Until KeyHit(1)
End 


	

	